package com.ruoyi;

import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.StringUtils;
import io.minio.MinioClient;
import io.minio.ObjectWriteArgs;
import io.minio.PutObjectArgs;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.rendering.PDFRenderer;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Date;

@SpringBootTest
public class TestPdfBox {

//    @Value("${minio.bucketName}")
    private static String bucketName = "vehicle-quality-review-oss";

//    @Value("${minio.url}")
//    private static String minioEndpoint = "http://106.3.99.64:22013";
    private static String minioEndpoint = "http://10.12.48.79:22038";

//    @Value("${minio.accessKey}")
//    private static String accessKey = "FNGqDZnHJhrugLlZBh77";
    private static String accessKey = "jockOVg2UG0dy2GZ";

//    @Value("${minio.secretKey}")
//    private static String secretKey = "TvnWeQxAQ1OYiAN68qlzEDJl5RqZ7tQYTMJ8XM0M";
    private static String secretKey = "AIZ4Ppls4xYrheSZfik8vbq4v6i1wm7m";

    @Test
    public static void main(String[] args) throws IOException {
        String url = "http://10.12.48.79:22038/vehicle-quality-review-oss/2024/06/24/车型审查原始记录-202406241741.pdf";
        String pictureUrl = processRemotePDF(url);
        System.out.println(pictureUrl);
    }

    public static String processRemotePDF(String urlStr) throws IOException {
        URL url = new URL(urlStr);
        String pictureUrl = "";

        // 打开远程连接
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        connection.setRequestMethod("GET");

        // 获取输入流
        try (InputStream inputStream = connection.getInputStream()) {
            // 加载PDF文档
            PDDocument doc = PDDocument.load(inputStream);
            PDFRenderer renderer = new PDFRenderer(doc);

            // 遍历每页pdf
            for (int i = 0; i < doc.getNumberOfPages(); i++) {
                // dpi调到300左右即可，太小会模糊，太大会使图片变得很大
                BufferedImage image = renderer.renderImageWithDPI(i, 300);

                // 将 BufferedImage 转换为 ByteArrayOutputStream
                ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
                ImageIO.write(image, "jpg", outputStream);
                pictureUrl += uploadMinio(outputStream,"车辆试验原始记录_" + i + getReportName() + ".jpg") + ",";
            }

            // 关闭文档
            doc.close();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 关闭连接
            connection.disconnect();
        }

        if (pictureUrl.endsWith(",")) {
            pictureUrl = pictureUrl.substring(0, pictureUrl.length() - 1);
        }

        return pictureUrl;
    }

    /**
     * 上传到minio
     * @param outputStream 输出流
     * @param fileName 文件名
     * @return minio存储地址
     */
    private static String uploadMinio(ByteArrayOutputStream outputStream, String fileName) throws Exception {
        // 1.连接Minio
        MinioClient minioClient =MinioClient.builder()
                .endpoint(minioEndpoint)
                .credentials(accessKey, secretKey)
                .build();
        // 2.上传
        // 把os流转为is流
        ByteArrayInputStream inputStream = new ByteArrayInputStream(outputStream.toByteArray());
        String newFileName = assemblyPdfName(fileName);
        PutObjectArgs putObjectArgs = PutObjectArgs.builder()
                .bucket(bucketName)
                .object(newFileName)
                .contentType("image/jpeg")
                .stream(inputStream, inputStream.available(), ObjectWriteArgs.MIN_MULTIPART_SIZE).build();
        minioClient.putObject(putObjectArgs);
        return newFileName;
    }

    /**
     * 拼接文件名
     * @param name
     * @return
     */
    public static String assemblyPdfName(String name) {
        return StringUtils.format("{}/{}", DateUtils.datePath(), name);
    }
    private static String getReportName() {
        return DateUtils.parseDateToStr("yyyyMMddHHmm", new Date());
    }
}
